include io.inc
include iost.inc
include string.inc
include wsub.inc
include fblk.inc
include unzip.inc
include alloc.inc

ZIP_LOCALID	equ 04034B50h	; signature local file
ZIP_CENTRALID	equ 02014B50h	; signature central file
ZIP_ENDSENTRID  equ 06054B50h	; signature end central

public  arc_flength

.data
externdef	_bufin:byte
LT256		label byte
		db   0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15
		db  16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31
		db  32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47
		db  48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63
		db  64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79
		db  80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 47, 93, 94, 95
		db  96, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79
		db  80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90,123,124,125,126,127
		db 128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143
		db 144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159
		db 160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175
		db 176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191
		db 192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207
		db 208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223
		db 224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239
		db 240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
arc_flength	dd 0
arc_pathz	dd 0

.code

getendcentral proc private uses ebx wsub:dword, zend:dword
	invoke wsopenarch,wsub
	mov STDI.ios_file,eax
	inc eax
	.if eax
	    invoke oseekl,0,SEEK_END
	    .if !ZERO?
		mov eax,STDI.ios_offset
		mov arc_flength,eax
		.if eax >= SIZE S_ZEND
		    invoke oungetc
		    .if !ZERO? && STDI.ios_i >= SIZE S_ZEND-1
			sub STDI.ios_i,SIZE S_ZEND-2
			.repeat
			    invoke oungetc
			    .if !ZERO?
				.continue .if al != 'P'
				mov eax,SIZE S_ZEND
				invoke oread
				mov ebx,eax
				.if !ZERO?
				    .continue .if dword ptr [ebx] != ZIP_ENDSENTRID
				    invoke memcpy,zend,ebx,SIZE S_ZEND
				    mov eax,1
				    jmp @F
				.endif
				.break
			    .endif
			    .break
			.until 0
		    .endif
		.endif
	    .endif
	    invoke close,STDI.ios_file
	    xor eax,eax
	.endif
     @@:
	test eax,eax
	ret
getendcentral endp

zip_allocfblk proc private uses esi edi ebx
	mov	edi,eax
	mov	esi,offset entryname
	invoke  strlen,esi
	add	eax,SIZE S_FBLK
	push	eax
	add	eax,12
	invoke  malloc,eax
	pop	ecx
	jz	alloc_fail
	mov	ebx,eax
	mov	ax,zip_central.cz_ext_attrib
	and	eax,_A_FATTRIB
	or	eax,zip_attrib
	mov	[ebx],eax
	cmp	edi,2
	jne	alloc_file
	mov	edi,ecx
	cmp	zip_central.cz_version_made,0
	jne	@F
	test	byte ptr zip_central.cz_ext_attrib,_A_SUBDIR
	jnz	set_block
      @@:
	mov	eax,_A_SUBDIR
	or	eax,zip_attrib
	mov	[ebx],eax
	jmp	set_block
  alloc_file:
	mov	edi,ecx
	sub	eax,eax
	mov	dword ptr [ebx].S_FBLK.fb_size[4],eax
	mov	eax,zip_central.cz_fsize
	mov	dword ptr [ebx].S_FBLK.fb_size,eax
  set_block:
	push	ebx
	mov	ax,zip_central.cz_date
	shl	eax,16
	mov	ax,zip_central.cz_time
	mov	[ebx].S_FBLK.fb_time,eax
	add	ebx,S_FBLK.fb_name
	invoke  strcpy,ebx,esi
	sub	eax,S_FBLK.fb_name
	add	edi,eax
	mov	eax,zip_central.cz_off_local
	mov	[edi],eax
	mov	eax,zip_central.cz_csize
	mov	[edi+4],eax
	mov	eax,zip_central.cz_crc
	mov	[edi+8],eax
	pop	eax
  alloc_fail:
	ret
zip_allocfblk endp

zip_readcentral proc private uses esi edi
	mov	eax,SIZE S_CZIP
	invoke  oread
	mov	ebx,eax
	jz	toend
	sub	eax,eax
	cmp	dword ptr [ebx],ZIP_CENTRALID
	jne	toend
	add	STDI.ios_i,SIZE S_CZIP
	dec	eax
	mov	edx,arc_pathz
	cmp	[ebx].S_CZIP.cz_fnsize,dx
	jbe	toend
	mov	edi,offset zip_central
	mov	esi,ebx
	mov	eax,ecx
	mov	ecx,SIZE S_CZIP / 4
	rep	movsd
	movsw
	movzx	ecx,[ebx].S_CZIP.cz_fnsize
	add	ebx,SIZE S_CZIP
	sub	eax,SIZE S_CZIP
	cmp	eax,ecx
	jae	@readcentral_name
	mov	eax,ecx
	invoke  oread
	mov	ebx,eax
	jz	toend
	movzx	ecx,zip_central.cz_fnsize
  @readcentral_name:
	mov	esi,ebx
	mov	edi,offset entryname
	mov	eax,ecx
	and	eax,3
	shr	ecx,2
	rep	movsd
	mov	ecx,eax
	rep	movsb
	mov	byte ptr [edi],0
	movzx	eax,zip_central.cz_fnsize
	add	STDI.ios_i,eax
	mov	ecx,eax
	mov	eax,_FB_ARCHZIP or _A_ARCH
	test	byte ptr zip_central.cz_bitflag,1
	jz	@F
	or	eax,_FB_ZENCRYPTED
     @@:
	test	byte ptr zip_central.cz_bitflag,8
	jz	@F
	or	eax,_FB_ZEXTLOCHD
     @@:
	mov	zip_attrib,eax
	mov	eax,'/'
	dec	edi
	cmp	[edi],al
	jne	@F
	mov	[edi],ah
	or	zip_attrib,_A_SUBDIR
	dec	zip_central.cz_fnsize
     @@:
	movzx	edi,zip_central.cz_extsize
	add	di,zip_central.cz_cmtsize
	test	edi,edi
	jz	@F
	mov	eax,edi
	invoke  oread
	mov	ebx,eax
	jz	toend
	add	STDI.ios_i,edi
     @@:
	mov	eax,1
  toend:
	test	eax,eax
	ret
zip_readcentral endp

zip_testcentral proc private uses esi edi wsub:dword
	mov edi,wsub
	lea esi,entryname
	mov edi,[edi].S_WSUB.ws_arch
	mov al,[edi]
	.if al
	    sub eax,eax
	    mov edx,eax
	    mov ecx,arc_pathz
	    inc ecx
	    @@:
		dec ecx
		jz @F
		mov al,[esi]
		mov dl,[edi]
		inc esi
		inc edi
		cmp dl,al
		je @B
		mov al,LT256[eax]
		mov dl,LT256[edx]
		cmp dl,al
		je @B
	    @@:
	    sub al,dl
	    mov eax,0
	    jnz @F
	.endif
	mov esi,wsub
	sub edi,[esi].S_WSUB.ws_arch
	lea esi,entryname
	.if edi
	    .if entryname[edi] == '/'
		mov eax,esi
		inc eax
		add eax,edi
		invoke strcpy,esi,eax
	    .else
		jmp @F
	    .endif
	.endif
	.if entryname == ','
	    mov eax,esi
	    inc eax
	    invoke strcpy,esi,eax
	.endif
	invoke strchr,esi,'/'
	.if !ZERO?
	    mov byte ptr [eax],0
	    invoke wsearch,wsub,esi
	    .if eax == -1
		mov eax,2
	    .else
		xor eax,eax
	    .endif
	.else
	    invoke wsearch,wsub,esi
	    .if eax == -1
		mov eax,1
	    .else
		mov edx,wsub
		mov edx,[edx].S_WSUB.ws_fcb
		mov edx,[edx+eax*4]
		mov ax,zip_central.cz_date
		shl eax,16
		mov ax,zip_central.cz_time
		mov [edx].S_FBLK.fb_time,eax
		.if zip_central.cz_version_made == 0
		    mov eax,zip_attrib
		    or  ax,zip_central.cz_ext_attrib
		    and eax,_A_FATTRIB
		    mov [edx],eax
		.endif
		xor eax,eax
	    .endif
	.endif
      @@:
	ret
zip_testcentral endp

zip_findnext proc private
	.while zip_readcentral()
	    inc eax
	    .if eax
		invoke zip_testcentral,edi
	    .else
		movzx eax,[ebx].S_CZIP.cz_extsize
		add ax,[ebx].S_CZIP.cz_cmtsize
		add ax,[ebx].S_CZIP.cz_fnsize
		push eax
		invoke oread
		mov ebx,eax
		pop edx
		.break .if ZERO?
		add STDI.ios_i,edx
		xor eax,eax
	    .endif
	    .if eax
		invoke zip_allocfblk
		.break
	    .endif
	.endw
	ret
zip_findnext endp

wzipread proc uses esi edi ebx wsub:dword
local alloc:byte
local fblk:dword
local rbuf[2048]:byte
	sub	eax,eax
	mov	STDI.ios_i,eax
	mov	STDI.ios_c,eax
	mov	STDI.ios_flag,eax
	mov	alloc,al
	.if malloc(200000h)
	    mov ecx,200000h
	    mov alloc,1
	.else
	    lea eax,rbuf
	    mov ecx,2048
	.endif
	mov	STDI.ios_size,ecx
	mov	STDI.ios_bp,eax
	mov	eax,wsub
	invoke  strlen,[eax].S_WSUB.ws_arch
	mov	arc_pathz,eax
	mov	edi,wsub
	invoke  wsfree,edi
	invoke  getendcentral,edi,addr zip_endcent
	jz	error
	invoke  fbupdir,_FB_ARCHZIP
	mov	[edi].S_WSUB.ws_count,1
	mov	edx,[edi].S_WSUB.ws_fcb
	mov	[edx],eax
	invoke  oseek,zip_endcent.ze_off_cent,SEEK_SET
	invoke  zip_findnext
	mov	fblk,eax
	.while eax
	    mov cl,[eax]
	    .if cl & _A_SUBDIR
	      @@:
		mov ecx,fblk
		mov eax,[edi].S_WSUB.ws_count
		mov edx,[edi].S_WSUB.ws_fcb
		mov [edx+eax*4],ecx
		inc eax
		mov [edi].S_WSUB.ws_count,eax
		.break .if eax >= [edi].S_WSUB.ws_maxfb
	    .else
		add eax,S_FBLK.fb_name
		invoke cmpwarg,eax,[edi].S_WSUB.ws_mask
		jnz @B
		invoke free,fblk
	    .endif
	    invoke zip_findnext
	    mov fblk,eax
	.endw
	invoke  oclose,addr STDI
	mov	eax,[edi].S_WSUB.ws_count
  toend:
	.if alloc
	    invoke free,STDI.ios_bp
	.endif
	ret
  error:
	mov	eax,-2
	jmp	toend
wzipread endp

	END
